#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef unsigned int uint;
typedef pair<int, int> pii;

void mcin() {}

template<typename T, typename ...Tail>
void mcin(T &&arg, Tail &&...args) {
    cin >> arg;
    mcin(args...);
}
#define in(type, ...) type __VA_ARGS__; mcin(__VA_ARGS__);

template<typename T1, typename T2>
istream &operator>>(istream &in, pair<T1, T2> &p) {
    return in >> p.first >> p.second;
}

template<typename T>
istream &operator>>(istream &in, vector<T> &v) {
    for (auto &item: v)
        in >> item;
    return in;
}

template<typename T1, typename T2>
struct phash {
    size_t operator()(pair<T1, T2> const &p) const {
        return (hash<T1>()(p.first) * 177013u) ^ hash<T2>()(p.second);
    }
};

#define all(c) c.begin(), c.end()

inline pii around(pii const &p, int it) {
    // @formatter:off
    static const vector<pii> shifts{
            {-1, 0}, {0,  -1}, {1,  -1},
            {1,  0}, {0,  1}, {-1, 1}
    };
    // @formatter:on
    return {p.first + shifts[it].first, p.second + shifts[it].second};
}

inline int mod3(int x) {
    int d = x % 3;
    return d < 0 ? d + 3 : d;
}

int main() {

    in(int, n, cost)
    in(double, gamma)
    vector<pii> xy(n);
    cin >> xy;
    unordered_set<pii, phash<int, int>> cells(all(xy));

    vector<pii> ans;
    vector<int> cnt(3);
    for (auto const &p: xy) {
        int count = 0;
        for (int i = 0; i < 6; i++)
            if (cells.count(around(p, i)) && cells.count(around(p, (i + 1) % 6)))
                count++;
        if (count > 0) {
            ans.push_back(p);
            int c = mod3(p.second - p.first);
            cnt[c]++;
        }
    }

    vector<pii> opts;
    for (int i = 0; i < 3; i++)
        opts.push_back({cnt[i], i});
    sort(all(opts));
    int opt = opts[0].second;

    cout << opts[0].first << '\n';
    for (auto const &p: ans)
        if (mod3(p.second - p.first) == opt)
            cout << p.first << ' ' << p.second << '\n';

}