#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef unsigned int uint;
typedef pair<int, int> pii;

void mcin() {}

template<typename T, typename ...Tail>
void mcin(T &&arg, Tail &&...args) {
    cin >> arg;
    mcin(args...);
}
#define in(type, ...) type __VA_ARGS__; mcin(__VA_ARGS__);

template<typename T1, typename T2>
istream &operator>>(istream &in, pair<T1, T2> &p) {
    return in >> p.first >> p.second;
}

template<typename T>
istream &operator>>(istream &in, vector<T> &v) {
    for (auto &item: v)
        in >> item;
    return in;
}

template<typename T1, typename T2>
struct phash {
    size_t operator()(pair<T1, T2> const &p) const {
        return (hash<T1>()(p.first) * 177013u) ^ hash<T2>()(p.second);
    }
};

#define all(c) c.begin(), c.end()

inline pii around(pii const &p, int it) {
    // @formatter:off
    static const vector<pii> shifts{
            {-1, 0}, {0,  -1}, {1,  -1},
            {1,  0}, {0,  1}, {-1, 1}
    };
    // @formatter:on
    return {p.first + shifts[it].first, p.second + shifts[it].second};
}

int main() {

    in(int, n, cost)
    in(double, gamma)
    vector<pii> xy(n);
    cin >> xy;

    unordered_set<pii, phash<int, int>> cells(all(xy));
    auto checkCell = [&](pii const &p) {
        uint nei = 0u;
        for (uint i = 0; i < 6; i++) {
            if (cells.count(around(p, i))) {
                if (i > 0 && ((nei >> (i - 1u)) & 1u))
                    return false;
                nei |= (1u << i);
            }
        }
        return (nei & 0b100001) < 0b100001;
    };

    int res = n;
    uint ans = 0;
    for (uint mask = 0; mask < (1u << n); mask++) {
        int cnt = 0;
        for (uint i = 0; i < n; i++)
            if ((mask >> i) & 1) {
                cnt++;
                cells.erase(xy[i]);
            }

        bool ok = cnt < res;
        for (auto const &p: cells)
            ok = ok && checkCell(p);
        if (ok) {
            res = cnt;
            ans = mask;
        }

        for (uint i = 0; i < n; i++)
            if ((mask >> i) & 1) cells.insert(xy[i]);
    }

    cout << res << '\n';
    for (uint i = 0; i < n; i++)
        if ((ans >> i) & 1)
            cout << xy[i].first << ' ' << xy[i].second << '\n';

}