
#include <bits/stdc++.h>

#define pii pair<int, int>
#define pb push_back
#define ll long long
#define S second
#define F first
#define ld long double
#define sqr(x) (x)*(x)
#define all(x) (x).begin(),(x).end()

using namespace std;

const int N = (1 << 20);

struct line {
    ll k, b; // y = kx + b
    ll get(int x) {
        return k * x + b;
    }
    line(ll k1, ll b1){
        k = k1;
        b = b1;
    }
    line(){ k = 0; b = -1e18;}
} t[N];
void update(int v, int cl, int cr, line L) {
    if(cl > cr) return;
    int mid = cl + cr;
    mid >>= 1;
    bool f1, f2;
    f1 = L.get(cl - N / 4) > t[v].get(cl - N / 4);
    f2 = L.get(mid - N / 4) > t[v].get(mid - N / 4);
    if(f2) {
        swap(L, t[v]);
    }
    if(f1 != f2) {
        update(v * 2, cl, mid - 1, L);
    } else {
        update(v * 2 + 1, mid + 1, cr, L);
    }
    return;
}
ll get(int x) {
    int v = (x + N / 4) + N / 2;
    ll answer = -1e18;
    while(v) {
        answer = max(answer, t[v].get(x));
        v>>=1;
    }
    return answer;
}
main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    ll n, c;
    cin >> n >> c;
    vector < ll > x(n);
    vector < ll > pref(n, 0);

    for(int i = 0;i < n; i++) {
        cin >> x[i];
        pref[i] = ((!!i) ? pref[i - 1] : 0) + sqr(x[i] - c);
    }
    vector < ll > dp(n, 0);
    for(int i = 0; i < n; i++) {
        if(i) dp[i] = get(x[i]) + pref[i - 1] + sqr(x[i]);
        line L = line(-2 * x[i], -pref[i] + dp[i] + sqr(x[i]));
        update(1, 0, N / 2 - 1, L);
    }
    cout << dp[n - 1] << "\n";
    return 0;
}
