import java.io.*;
import java.util.*;

public class ShiftAndReverseBF {

    void solve() {
        int n = in.nextInt(), m = in.nextInt();
        String s = in.next(), t = in.next();
        Map<String, String> prev = new HashMap<>();
        Map<String, Integer> prevMove = new HashMap();
        Queue<String> q = new ArrayDeque<>();
        prev.put(s, null);
        q.add(s);
        while (!q.isEmpty()) {
            String cur = q.poll();
            if (cur.equals(t)) {
                break;
            }

            for (int pos = 0; pos <= n; pos++) {
                String next = reverse(cur.substring(pos)) + cur.substring(0, pos);
                if (!prev.containsKey(next)) {
                    prev.put(next, cur);
                    prevMove.put(next, pos);
                    q.add(next);
                }
            }
        }
        if (!prev.containsKey(t)) {
            out.println(-1);
            return;
        }
        List<Integer> moves=  new ArrayList<>();
        while (!t.equals(s)) {
            moves.add(prevMove.get(t));
            t = prev.get(t);
        }
        Collections.reverse(moves);
        out.println(moves.size());
        for (int i : moves) {
            out.print((n - i) + " ");
        }
    }

    String reverse(String s) {
        return new StringBuilder(s).reverse().toString();
    }

    FastScanner in;
    PrintWriter out;

    void run() {
        in = new FastScanner(System.in);
        out = new PrintWriter(System.out);
        solve();
        out.close();
    }

    public class FastScanner {
        BufferedReader br;
        StringTokenizer st;

        public FastScanner(InputStream in) {
            br = new BufferedReader(new InputStreamReader(in));
        }

        public int nextInt() {
            return Integer.parseInt(next());
        }

        public boolean hasMoreTokens() {
            while (st == null || !st.hasMoreElements()) {
                String line = null;
                try {
                    line = br.readLine();
                } catch (IOException e) {
                    return false;
                }
                if (line == null) {
                    return false;
                }
                st = new StringTokenizer(line);
            }
            return true;
        }

        public String next() {
            while (st == null || !st.hasMoreElements()) {
                String line = null;
                try {
                    line = br.readLine();
                } catch (IOException e) {
                }
                st = new StringTokenizer(line);
            }
            return st.nextToken();
        }

        public long nextLong() {
            return Long.parseLong(next());
        }

        public double nextDouble() {
            return Double.parseDouble(next());
        }

        public int[] nextIntArray(int n) {
            int[] ret = new int[n];
            for (int i = 0; i < n; i++) {
                ret[i] = nextInt();
            }
            return ret;
        }
    }


    public static void main(String[] args) {
        new ShiftAndReverseBF().run();
    }
}