#include "testlib.h"

using namespace std;

using ll = long long;

int main(int argc, char *argv[]) {
    registerGen(argc, argv, 1);

    int n = opt<int>("n");
    auto p = opt<double>("p");
    double s = has_opt("s") ? opt<double>("s") : 1;
    int cost = opt<int>("cost");
    auto gamma = opt<double>("gamma");

    int max_xy = static_cast<int>(sqrt(static_cast<double>(n) / p));

    int max_x = static_cast<int>(max_xy * s);
    int max_y = static_cast<int>(max_xy / s);
    n = max(1, min(n, max_x * max_y));

    set<pair<int, int>> was;
    vector<pair<int, int>> tailes;

    for (int i = 0; i < n; ++i) {
        do {
            int x = rnd.next(0, max_x);
            int y = rnd.next(0, max_y);
            if (was.find(make_pair(x, y)) == was.end()) {
                was.emplace(x, y);
                tailes.emplace_back(x, y);
                break;
            }
        } while (true);
    }

    println(n, cost, gamma);
    for (int i = 0; i < n; ++i) {
        println(tailes[i].first, tailes[i].second);
    }
}