#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef unsigned int uint;
typedef pair<int, int> pii;

void mcin() {}

template<typename T, typename ...Tail>
void mcin(T &&arg, Tail &&...args) {
    cin >> arg;
    mcin(args...);
}
#define in(type, ...) type __VA_ARGS__; mcin(__VA_ARGS__);

template<typename T1, typename T2>
istream &operator>>(istream &in, pair<T1, T2> &p) {
    return in >> p.first >> p.second;
}

template<typename T>
istream &operator>>(istream &in, vector<T> &v) {
    for (auto &item: v)
        in >> item;
    return in;
}

template<typename T1, typename T2>
struct phash {
    size_t operator()(pair<T1, T2> const &p) const {
        return (hash<T1>()(p.first) * 177013u) ^ hash<T2>()(p.second);
    }
};

#define all(c) c.begin(), c.end()

inline pii around(pii const &p, int it) {
    // @formatter:off
    static const vector<pii> shifts{
            {-1, 0}, {0,  -1}, {1,  -1},
            {1,  0}, {0,  1}, {-1, 1}
    };
    // @formatter:on
    return {p.first + shifts[it].first, p.second + shifts[it].second};
}

int main() {

    in(int, n, cost)
    in(double, gamma)
    vector<pii> xy(n);
    cin >> xy;
    unordered_set<pii, phash<int, int>> cells(all(xy));

    vector<pii> ans;
//    random_device rd;
    mt19937 mte(177013);
    shuffle(all(xy), mte);
    for (auto const &p: xy) {
        if (cells.count(around(p, 0)) && cells.count(around(p, 1)) ||
            cells.count(around(p, 3)) && cells.count(around(p, 4))) {
            ans.push_back(p);
            cells.erase(p);
        }
    }

    cout << ans.size() << '\n';
    for (auto const &p: ans)
        cout << p.first << ' ' << p.second << '\n';

}