#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef unsigned int uint;
typedef pair<int, int> pii;

void mcin() {}

template<typename T, typename ...Tail>
void mcin(T &&arg, Tail &&...args) {
    cin >> arg;
    mcin(args...);
}
#define in(type, ...) type __VA_ARGS__; mcin(__VA_ARGS__);

template<typename T1, typename T2>
istream &operator>>(istream &in, pair<T1, T2> &p) {
    return in >> p.first >> p.second;
}

template<typename T>
istream &operator>>(istream &in, vector<T> &v) {
    for (auto &item : v)
        in >> item;
    return in;
}

#define all(c) c.begin(), c.end()

inline pii around(pii const &p, int it) {
    // @formatter:off
    static const vector<pii> shifts{
            {-1, 0}, {0,  -1}, {1,  -1},
            {1,  0}, {0,  1}, {-1, 1}
    };
    // @formatter:on
    return {p.first + shifts[it].first, p.second + shifts[it].second};
}

inline int mod3(int x) {
    int d = x % 3;
    return d < 0 ? d + 3 : d;
}

vector<pii> xy;

vector<vector<int>> g, ch;
vector<int> up, tin, vis;
int t = 0;

int dfs(int v, int p) {
    vis[v] = true;
    up[v] = tin[v] = t++;
    for (int u : g[v]) {
        if (u == p) continue;
        if (vis[u]) up[v] = min(up[v], tin[u]);
        else {
            up[v] = min(up[v], dfs(u, v));
            ch[v].push_back(u);
        }
    }

    return up[v];
}

vector<int> vis2;

void dfs2(int v, vector<vector<int>> &ans) {
    vis2[v] = true;
    auto cell = xy[v];
    int color = mod3(cell.second - cell.first);
    ans[color].push_back(v);

    for (int u : ch[v]) {
        if (up[u] > tin[v]) continue;
        dfs2(u, ans);
    }
}

int main() {

    in(int, n, cost)
    in(double, gamma)
    xy.resize(n);
    cin >> xy;
    map<pii, int> cells;
    for (int i = 0; i < n; i++) {
        cells[xy[i]] = i;
    }

    g.resize(n);
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < 6; j++) {
            auto nei = around(xy[i], j);
            if (cells.count(nei)) {
                g[i].push_back(cells[nei]);
            }
        }
    }
    up.resize(n);
    tin.resize(n);
    vis.resize(n);
    ch.resize(n);
    for (int i = 0; i < n; i++) {
        if (!vis[i]) dfs(i, -1);
    }

    set<pii> ans;
    vis2.resize(n);
    for (int i = 0; i < n; i++) {
        if (!vis2[i]) {
            vector<vector<int>> res(3);
            dfs2(i, res);
            if (res[0].size() > res[1].size()) swap(res[0], res[1]);
            if (res[0].size() > res[2].size()) swap(res[0], res[2]);
            for (int v : res[0]) ans.insert(xy[v]);
        }
    }

    cout << ans.size() << '\n';
    for (auto const &p : ans)
        cout << p.first << ' ' << p.second << '\n';

}
